#ifndef __LCD_H_
#define __LCD_H_
#include "stm32f10x_conf.h"
#include "hw_config.h"

#define LCD_CS(n)			PCout(8)=n	
#define LCD_RS(n)			PCout(9)=n
#define LCD_WR(n)			PCout(10)=n
#define LCD_RD(n)			PCout(11)=n

//#define DataToWrite(DATA)	GPIO_Write(GPIOE, DATA)  
//#define DataToRead()	    GPIO_ReadOutputData(GPIOE) 

/*-----*/
#define  HDP  799  //Horizontal Display Period
#define  HT   1000 //Horizontal Total
#define  HPS  51   //LLINE Pulse Start Position
#define  LPS  3    //Horizontal Display Period Start Position
#define  HPW  8    //LLINE Pulse Width


#define  VDP  479	//Vertical Display Period
#define  VT   530	//Vertical Total
#define  VPS  24	//LFRAME Pulse Start Position
#define  FPS  23	//Vertical Display Period Start Positio
#define  VPW  3 	//LFRAME Pulse Width


/*Private define-------------------------*/
#define POINT_COLOR RED
#define BACK_COLOR	0xFFFF

/*--------16λɫֵ---------------*/
#define WHITE         	 0xFFFF
#define BLACK         	 0x0000	  
#define BLUE         	 0x001F  
#define RED           	 0xF800
#define MAGENTA       	 0xF81F
#define GREEN         	 0x07E0
#define CYAN          	 0x7FFF
#define YELLOW        	 0xFFE0
#define BROWN 			 0XBC40 //ɫ
#define BRRED 			 0XFC07 //غɫ
#define GRAY  			 0X8430 //ɫ
#define LGRAY 			 0XC618 //ǳɫ

/*----------------------*/
void LCD_Clear(uint16_t Color);

/*-----APIͼ------*/
void LCD_Fill(uint8_t xsta, uint16_t ysta, uint8_t xend, uint16_t yend, uint16_t colour);
void LCD_DrawLine(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color);
void Draw_Circle(uint16_t x0, uint16_t y0, uint8_t r, uint16_t color);
void LCD_DrawRectangle(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color);

/*Զַʾ(Ӣ)FONT.h
  ַС8*16 ִС16*16  */
void LCD_ShowString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor);
void LCD_ShowNum(u8 x,u8 y,u32 num,u8 len, u16 PenColor, u16 BackColor);


/*ԶͼƬʾFONT.h 
  gImageȡbmpͼƬC*/
void LCD_DrawPicture(u16 StartX,u16 StartY,u16 Xend,u16 Yend,u8 *pic);

/* LCDʼ ˿ڡFSMC */
void LCD_Init(void);

#endif
